Title Antras Kolis

.model small
        FailoKelias     EQU     125
        BufConst        EQU     20

.stack 100h
.data

        ivDuom  db "Iveskite duomenu failo pavadinima: $"
        ivRez   db 10, 13, "Iveskite rezultatu failo pavadinima: $"
		enteris db  13, 10, "$"
        duomk   db FailoKelias, ?
        duom    db FailoKelias dup (?)
        rezk    db FailoKelias, ?
        rez     db FailoKelias dup (?)
        sBuf    db BufConst dup (?)
        rBuf    db BufConst dup (?)
        dHandle dw ?
        rHandle dw ?       

        ErrDalIras  db 10, 13, "**Klaida .Atliktas tik dalinis irasymas. $"
        ErrRas db 10, 13, "**Klaida irasinejant i faila. $"
        ErrSk  db 10, 13, "**Klaida skaitant faila. $"
        ErrOpDF    db 10, 13, "**Klaida atidarant duomenu faila. $"
        ErrOpRF    db 10, 13, "**Klaida atidarant rezultatu faila. $"
        ErrClDF    db 10, 13, "**Klaida uzdarant duomenu faila. $"
        ErrClRF    db 10, 13, "**Klaida uzdarant rezultatu faila. $"
		pran1 DB 10, 13"Programa parase: Gintaras Dreizas Programu Sistemu 4 grupe. $"

.code
  Pradzia:

        MOV             ax, @data
        MOV             ds, ax
;*************Duom ir rez failu ivedimas ir atidarymas******************       
        MOV             dx, OFFSET ivDuom
        MOV             ah, 9
        INT             21h


        MOV             dx, OFFSET duomk
        MOV             ah, 0Ah
        INT             21h

       
        MOV             bx, OFFSET duomk
        INC             bx
        MOV             cl, ds:[bx]
        INC             cx
        ADD             bx, cx
        MOV             byte ptr ds:[bx], 0

        MOV             dx, OFFSET duom
        MOV             ah, 3Dh
        MOV             al, 0
        INT             21h
        JC              ErrorOnOpeningDF
        MOV             dHandle, ax

        MOV             dx, OFFSET ivRez
        MOV             ah, 9
        INT             21h

       
        MOV             dx, OFFSET rezk
        MOV             ah, 0Ah
        INT             21h

       
        MOV             bx, OFFSET rezk
        INC             bx
        MOV             cl, ds:[bx]
        INC             cx
        ADD             bx, cx
        MOV             byte ptr ds:[bx], 0

       
        MOV             dx, OFFSET rez
        MOV             ah, 3Ch
        MOV             cx, 0
        INT             21h
        JC              ErrorOnOpeningRF
        MOV             rHandle, ax
        JMP             skaityk

;***************Klaidos**************************************
  ErrorOnOpeningDF:
        MOV             ah, 9
        MOV             dx, OFFSET ErrOpDF
        INT             21h
        JMP             Exit

  ErrorOnOpeningRF:
        MOV             ah, 9
        MOV             dx, OFFSET ErrOpRF
        INT             21h
        JMP             UzdarytiDuomenuFaila

  ErrorOnClosingRF:
        MOV             ah, 9
        MOV             dx, OFFSET ErrClRF
        INT             21h
        JMP             UzdarytiDuomenuFaila

  ErrorOnClosingDF:
        MOV             ah, 9
        MOV             dx, OFFSET ErrClDF
        INT             21h    
        JMP             Exit

;************************************************************

;*************Duomenu nuskaitymas is failo*******************
  skaityk:
        MOV             bx, dHandle
        CALL    SkaitykBuf
        CMP             ax, 0
        JE              UzdarytiDuomenuFaila
       
        MOV             cx, ax
        MOV             si, OFFSET sBuf
        MOV             di, OFFSET rBuf
  dirbam:
        MOV             dl, [si]
        CMP             dl, 'a'
        JB              tesk
        CMP             dl, 'z'
        JA              tesk
        SUB             dl, 20h
 
  tesk:
        MOV             [di], dl
        INC             di
        INC             si
        LOOP    dirbam
 ;***********Irasymas i faila*********************************
        MOV             cx, ax
        MOV             bx, rHandle
        CALL    RasykBuf
        CMP             ax, BufConst
        JE              skaityk
  UzdarytiRezultatuFaila:
        MOV             ah, 3Eh
        MOV             bx, rHandle
        INT             21h
        JC              ErrorOnClosingRF
  UzdarytiDuomenuFaila:
        MOV             ah, 3Eh
        MOV             bx, dHandle
        INT             21h
        JC              ErrorOnClosingDF
 ;************Programos pabaiga*******************************  
  Exit:
		
		MOV				ah, 9
		LEA				dx, Baige
		INT				21h
		
		MOV				ah, 9
		MOV				dx, offset enteris
		INT				21h
		
        MOV             ah, 4Ch
        MOV             al, 0
        INT             21h
;************************************************************
 
PROC SkaitykBuf
        PUSH    cx
        PUSH    dx
       
        MOV             ah, 3Fh
        MOV             cl, BufConst
        MOV             ch, 0
        MOV             dx, OFFSET sBuf
        INT             21h
        JC              KlaidaSkaitant
       
  SkaitykBufPabaiga:
        POP             dx
        POP             cx
        RET
 
  KlaidaSkaitant:
        MOV             ah, 9
        MOV             dx, OFFSET ErrSk
        INT             21h
        MOV             ax, 0
        JMP             SkaitykBufPabaiga
SkaitykBuf ENDP
 
PROC RasykBuf
 
        PUSH    dx
       
        MOV             ah, 40h
        MOV             dx, OFFSET rBuf
        INT             21h
       
        JC              klaidaRasant
        CMP             cx, ax
        JNE     dalinisIrasymas
       
  RasykBufPabaiga:
        POP             dx
        RET
       
  dalinisIrasymas:
        PUSH    ax
        MOV             ah, 9
        MOV             dx, OFFSET ErrRas
        INT             21h
        POP             ax
        JMP     RasykBufPabaiga
       
  klaidaRasant:
        MOV             ah, 9
        MOV             dx, OFFSET ErrDalIras
        INT             21h
        MOV             ax, 0
        JMP             RasykBufPabaiga
 
RasykBuf ENDP
 
PROC Skaiciuok
 
        PUSH    ax
        PUSH    cx
        PUSH    dx
 
        MOV     cx, 10                                                          ;Kokia sistema isvesti skaiciu
        PUSH    "$"
  Dalink:
        MOV             dx, 0
        DIV             cx
        PUSH    		dx
        CMP             ax, 0
        JA              Dalink
        MOV             ah, 2

  Spausdink:
        POP             dx
        CMP             dx, "$$"
        JE              Pabaiga
        CMP             dx, 10
        JAE     Raide
        ADD             dl, '0'
        JMP             Spausdinam
               
  Raide:
        ADD             dx, 55
        JMP             Spausdinam
      
  Spausdinam:
        INT             21h
        JMP             Spausdink

  Pabaiga:
        POP             dx
        POP             cx
        POP             ax
        RET
Skaiciuok ENDP

END Pradzia